program GoldSearcher_level_editor;
uses crt,dos;
type
level=array[1..80,1..25] of char;
var
f: file of level;
cell: level;
x,y: byte;
ch: char;
name: string;
new,yes_menu: boolean;
attrib: word;
procedure write_or_move;
begin
textcolor(lightgray);
case ch of
#72 :
if y>1 then
y:=y-1;
#75 :
if x>1 then
x:=x-1;
#77 :
if x<80 then
x:=x+1;
#80 :
if y<24 then
y:=y+1;
'1' :
begin
textcolor(red);
cell[x,y]:='';
end;
'2' :
begin
textcolor(yellow);
cell[x,y]:='';
end;
'3' :
begin
textcolor(white);
cell[x,y]:='';
end;
'4' :
begin
textcolor(white);
cell[x,y]:='';
end;
'5' :
begin
textcolor(brown);
cell[x,y]:='';
end;
'7' :
begin
textcolor(lightblue);
cell[x,y]:='';
end;
'8' :
begin
textcolor(green);
cell[x,y]:='';
end;
'9' :
begin
textcolor(lightgreen);
cell[x,y]:='F';
end;
'0' :
cell[x,y]:=' ';
end;
if ch in ['0'..'5','7'..'9'] then
write(cell[x,y]);
end;
procedure create_or_open;
begin
clrscr;
write('  䠩(᫨ ⠪ 䠩 ,   㤥 ᮧ): ');
readln(name);
if pos('.',name)<>0 then
delete(name,pos('.',name),length(name)-pos('.',name)+1);
if name='' then
exit
else
name:=name+'.lev';
assign(f,name);
{$i-}
reset(f);
{$i+}
if ioresult<>0 then
begin
rewrite(f);
new:=true;
write('  䠩 ஢...  Enter...');
readln;
clrscr;
for y:=1 to 24 do
for x:=1 to 80 do
cell[x,y]:=' ';
end
else
begin
new:=false;
getfattr(f,attrib);
if attrib and archive=0 then
begin
write(' 㤠  䠩. ,  䠩 .  Enter...');
readln;
exit;
end;
write(' ஢ .  Enter...');
readln;
read(f,cell);
for y:=1 to 24 do
for x:=1 to 80 do
begin
gotoxy(x,y);
case cell[x,y] of
'' : textcolor(red);
'' : textcolor(yellow);
'' : textcolor(white);
'' : textcolor(white);
'' : textcolor(brown);
'' : textcolor(lightblue);
'' : textcolor(green);
'F' : textcolor(lightgreen);
else
textcolor(lightgray);
end;
write(cell[x,y]);
end;
end;
x:=1;
y:=1;
gotoxy(x,y);
repeat
ch:=readkey;
if ch=#0 then
ch:=readkey;
write_or_move;
gotoxy(x,y);
until ch=#27;
gotoxy(1,25);
write('࠭ ? 1 - . 2 - .');
ch:=readkey;
if ch='1' then
begin
seek(f,0);
write(f,cell);
close(f);
end
else
if new then
begin
close(f);
erase(f);
end
else
close(f);
write('  Enter...');
readln;
end;
procedure help;
var
help_file: text;
st: string;
begin
clrscr;
assign(help_file,'Editor.hlp');
{$i-}
reset(help_file);
{$i+}
if ioresult=0 then
begin
while not eof(help_file) do
begin
readln(help_file,st);
writeln(st);
end;
gotoxy(1,25);
write('뢮 ࠢ 襭.  Enter...');
readln;
close(help_file);
end
else
begin
gotoxy(1,25);
write(' ࠢ  .  Enter...');
readln;
end;
end;
begin		{}
yes_menu:=true;
repeat
clrscr;
gotoxy(22,10);
write(' ஢   "⮨᪠⥫".');
gotoxy(22,11);
write('롥  ⢨:');
gotoxy(22,12);
write('1.    ஢.');
gotoxy(22,13);
write('2.  ࠢ.');
gotoxy(22,14);
write('3. 室.');
ch:=readkey;
case ch of
'1' : create_or_open;
'2' : help;
'3' : yes_menu:=false;
end;
until not yes_menu;
gotoxy(1,25);
write(' 襭.  Enter...');
readln;
end.