program GoldSearcher;
uses crt,rem,dos;
type
level = array[1..80,1..25] of char;
slot = record
name: string[20];
time: word;
end;
hiscore = array[1..10] of slot;
const
standart_name='level';
var
high: file of hiscore;
hi: hiscore;
work: slot;
time: longint;
i,j,x,y,start_x,start_y: byte;
f: file of level;
cell: level;
ch: char;
name: string;
count: integer;
sobrano,yes_menu: boolean;
attrib: word;
procedure draw_ladder;
var
x,y: byte;
begin
textcolor(white);
for y:=1 to 24 do
for x:=1 to 80 do
if cell[x,y]='' then
begin
gotoxy(x,y);
cell[x,y]:='';
write(cell[x,y]);
end;
textcolor(lightgray);
end;
procedure fall;
begin         
while (y<>24) and (cell[x,y+1]<>'') and 
(cell[x,y+1]<>'')  and (cell[x,y]<>'') and (cell[x,y]<>'F') do
begin
gotoxy(x,y);
write('');
if cell[x,y]='' then
begin
count:=count-1;
cell[x,y]:=' ';
end;
if (count=0) and (not sobrano) then
begin
sobrano:=true;
draw_ladder;
end;
gotoxy(x,y);
delay(65);
time:=time+65;
case cell[x,y] of
'' : write(' ');
'' :
begin
textcolor(red);
write('');
end;
else
write(cell[x,y]);
end;
y:=y+1;
textcolor(lightgray);
end;
end;
procedure move;
procedure write_cell;
begin
gotoxy(x,y);
if cell[x,y]='' then
write(' ')
else
write(cell[x,y]);
end;		{ write_cell}
begin
textcolor(white);
case ch of
#75 :
if x>1 then
if (cell[x-1,y]<>'') and (cell[x-1,y]<>'') then
begin
write_cell;
x:=x-1;
end;
#77 :
if x<80 then
if (cell[x+1,y]<>'') and (cell[x+1,y]<>'') then
begin
write_cell;
x:=x+1;
end;
#72 :
if y>1 then
if (cell[x,y]='') and (cell[x,y-1]<>'') and (cell[x,y-1]<>'') then
begin
write_cell;
y:=y-1;
end;
#80 :
if y<24 then
if (cell[x,y+1]<>'') then
begin
write_cell;
y:=y+1;
end;
end;
textcolor(lightgray);
end;
procedure play_level;
begin
sobrano:=false;
if (start_x>0) and (start_y>0) then
begin
x:=start_x;
y:=start_y;
end
else
begin
x:=1;
y:=1;
end;
repeat
textcolor(lightgray);
if (cell[x,y+1]<>'') and (cell[x,y+1]<>'') and 
(cell[x,y]<>'') and (cell[x,y]<>'') then
fall;
gotoxy(x,y);
write('');
if cell[x,y]='' then
begin
count:=count-1;
cell[x,y]:=' ';
end;
if (count=0) and (not sobrano) then
begin
sobrano:=true;
draw_ladder;
end;
gotoxy(x,y);
if cell[x,y]<>'F' then
begin
if keypressed then
begin
ch:=readkey;
if ch=#0 then
ch:=readkey;
move;
if ch in ['r', ''] then
begin
close(f);
exit;
end;
end
else
begin
delay(1);
time:=time+1;
end;
end;
until (ch=#27) or (cell[x,y]='F');
gotoxy(1,25);
if (sobrano) and (cell[x,y]='F') then
write(' ᮡࠫ  !')
else
if (sobrano) and (ch=#27) then
write(' ᮡࠫ  ,   諨  䨭.')
else
write('  ᮡࠫ ',count,' ',Naim(count,'᮪','᪠','᪮'),' .');
write('  Enter...');
readln;
close(f);
end;
procedure initialize;
begin
count:=0;
start_x:=0;
start_y:=0;
read(f,cell);
for y:=1 to 24 do
for x:=1 to 80 do
begin
gotoxy(x,y);
textcolor(lightgray);
case cell[x,y] of
'' : textcolor(red);
'' :
begin
count:=count+1;
textcolor(yellow);
end;
'', '': textcolor(white);
'' :
begin
textcolor(red);
write('');
end;
'' :
begin
if (start_x=0) and (start_y=0) then
begin
start_x:=x;
start_y:=y;
end;
cell[x,y]:=' ';
end;
'' : write(' ');
'F' : textcolor(lightgreen);
end;
if not (cell[x,y] in ['','']) then
write(cell[x,y]);
end;
end;
procedure open_custom_level;
begin
clrscr;
write('  䠩 ஢: ');
readln(name);
if pos('.',name)<>0 then
delete(name,pos('.',name),length(name)-pos('.',name)+1);
if name='' then
exit
else
name:=name+'.lev';
assign(f,name);
{$i-}
reset(f);
{$i+}
if ioresult=0 then
begin
getfattr(f,attrib);
if attrib and archive=0 then
begin
write(' 㤠  䠩. ,  䠩 .  Enter...');
readln;
exit;
end;
write('   "',name,'" ᯥ譮 .  Enter...');
readln;
repeat
reset(f);
initialize;
play_level;
until not (ch in ['r', '']);
end
else
begin
write('   "',name,'"  .  Enter...');
readln;
end;
end;
function time_preobr(time: word): string;
function lz(time: word): string;
var
s: string;
begin
str(time,s);
if length(s)=1 then
s:='0'+s;
lz:=s;
end;
var
play_time: string;
begin
play_time:='';
if time>=3600 then
begin
play_time:=lz(time div 3600)+':';
time:=time mod 3600;
end;
play_time:=play_time+lz(time div 60)+':';
time:=time mod 60;
play_time:=play_time+lz(time);
time_preobr:=play_time;
end;
procedure output_hiscores;
var
st: string[8];
begin
clrscr;
{$i-}
reset(high);
{$i+}
if ioresult<>0 then
begin
gotoxy(1,25);
write(' ४म  ...  Enter...');
readln;
end
else
begin
read(high,hi);
gotoxy(17,6);
write(' ப');
gotoxy(52,6);
writeln('६ ');
for i:=1 to 10 do
begin
gotoxy(17,i+7);
writeln(hi[i].name);
st:=time_preobr(hi[i].time);
gotoxy(62-length(st),i+7);
write(st);
end;
gotoxy(1,25);
write('뢮 ⠡ ४म 襭.  Enter...');
readln;
close(high);
end;
end;
procedure open_level;
var
level_found: boolean;
begin
i:=1;
time:=0;
repeat
str(i,name);
assign(f,(standart_name+name+'.lev'));
{$i-}
reset(f);
{$i+}
if ioresult=0 then
begin
initialize;
play_level;
if not (ch in ['r', '']) then
i:=i+1;
end
else
begin
clrscr;
level_found:=false;
gotoxy(1,25);
write('    "',standart_name+name+
      '.lev','"  .  Enter...');
readln;
end;
until (ch=#27) or (not level_found) or (i-1=8);
clrscr;
if i-1=8 then
begin
work.time:=time div 1000;
writeln('६ 襩  - ',time_preobr(work.time),'.');
{$i-}
reset(high);
{$i+}
if ioresult<>0 then
begin
gotoxy(1,25);
write(' ४म  ...  Enter...');
readln;
exit;
end
else
read(high,hi);
if work.time<hi[10].time then
begin
writeln('ࠢ塞!    ⠡ ४म!');
write('  : ');
readln(work.name);
hi[10]:=work;
for i:=2 to 10 do
for j:=10 downto i do
if hi[j-1].time>hi[j].time then
begin
work:=hi[j-1];
hi[j-1]:=hi[j];
hi[j]:=work;
end;
seek(high,0);
write(high,hi);
end
else
begin
write(' ᮦ,   㤠   ⠡ ४म.  Enter...');
readln
end;
output_hiscores;
end
else
begin
write(' 㤠  ⮫쪮  ',i-1,'- ஢ . ⮡   ⠡ ४म,'+#13+#10+
			' 㦭 ன  ஢. ஡  ࠧ!');
gotoxy(1,25);
write(' 襭.  Enter...');
readln;
end;
end;
procedure help;
var
help_file: text;
st: string;
begin
clrscr;
assign(help_file,'Help.hlp');
{$i-}
reset(help_file);
{$i+}
i:=0;
if ioresult=0 then
begin
while not eof(help_file) do
begin
readln(help_file,st);
writeln(st);
i:=i+1;
if i=24 then
begin
i:=0;
gotoxy(1,25);
write(' Enter...');
readln;
clrscr;
end;
end;
gotoxy(1,25);
write('뢮 ࠢ 襭.  Enter...');
close(help_file);
end
else
begin
gotoxy(1,25);
write(' ࠢ  .  Enter...');
end;
readln;
end;
procedure Hide_Cursor;
   var Regs : Registers;
 begin
   with Regs do
    begin
      Ah := 1;
      Ch := $20;
      Cl := 0;
      Bh := 0;
      Intr($10,Regs);
    end;
 end;
begin		{ }
yes_menu:=true;
hide_cursor;
assign(high,'Scores.dat');
repeat
clrscr;
gotoxy(33,10);
write('⮨᪠⥫.');
gotoxy(26,11);
write('롥 ⢨:');
gotoxy(26,12);
write('1.   "⮨᪠⥫".');
gotoxy(26,13);
write('2.  ᮡ⢥ ஢.');
gotoxy(26,14);
write('3.  ४म.');
gotoxy(26,15);
write('4.  ࠢ.');
gotoxy(26,16);
write('5. 室.');
ch:=readkey;
case ch of
'1' : open_level;
'2' : open_custom_level;
'3' : output_hiscores;
'4' : help;
'5' : yes_menu:=false;
end;
until not yes_menu;
gotoxy(1,25);
write(' 襭.  Enter...');
readln;
end.