Unit
	Rem;
interface 

	uses
		Crt;

  function RoundTo(Num, MinUnit: real): real;
	function UpChar(Ch: char): char;
  function UpString(st: string): string;
	function DosToWin(st: string): string;
	function WinToDos(st: string): string;
	function RemReal(num: real): string;
	function Naim(num: integer; kind0, kind1, kind2: string): string;

implementation

	function RoundTo(Num, MinUnit: real): real;
  begin
  	RoundTo := Round(Num / MinUnit) * MinUnit;
  end;

  function UpChar(Ch: char): char;
  begin
  	Ch := UpCase(Ch);
    case Ch of
    	#160..#175: UpChar:=Chr(Ord(Ch) - 32);
      #224..#239: UpChar:=Chr(Ord(Ch) - 80);
      #241			: UpChar:=Chr(Pred(Ord(Ch)))
      else
        UpChar:=Ch;
    end;

  end;

  function UpString(st: string): string;
  var
  	i: integer;
  begin
    if st <> '' then
  	for i:=1 to Length(st) do
    	st[i]:=UpChar(st[i]);
    UpString:=st;
  end;

	function DosToWin(st: string): string;
	var
		i: byte;
	begin
		for i := 1 to Length(st) do
			case st[i] of
				#128..#175 : st[i] := chr(ord(st[i])+64);
				#224..#239 : st[i] := chr(ord(st[i])+16);
				#241       : st[i] := #184;
				#240       : st[i] := #168;
			end;
		DosToWin := st;
	end;

	function WinToDos(st: string): string;
	var
		i: byte;
	begin
		for i := 1 to Length(st) do
			case st[i] of
				#192..#239 : st[i] := chr(ord(st[i])-64);
				#240..#255 : st[i] := chr(ord(st[i])-16);
				#184       : st[i] := #241;
				#168       : st[i] := #240;
			end;
		WinToDos := st;
	end;

	function RemReal(num: real): string;
	var
	  st: string;
		i: integer;
	begin  
		str(num: 1: 10, st);
		i := length(st);
		while (st[i] = '0') and (st[i] <> '.') do
		begin
		  delete(st, i, 1);
		  i := i - 1;
		end;
		if st[length(st)] = '.' then
			delete(st, length(st), 1);
		RemReal := st;
	end;

	function Naim(num: integer; kind0, kind1, kind2: string): string;
	begin
		Naim := kind2;
		if num div 10 mod 10 <> 1 then
				case num mod 10 of
					1   : Naim := kind0;
					2..4: Naim := kind1;
				end;
	end;
end.

